:li
#!/usr/bin/perl -w

#----------------------------------
package Basepac1;
#----------------------------------
### Constructor
sub new            
{ my $type = shift; 
  my $self = {};

  $self->{'b11'} = "b11";
  $self->{'b12'} = "b12";

  bless $self, $type;
}

#----------------------------------
package Basepac2;
#----------------------------------
### Constructor
sub new            
{ my $type = shift; 
  my $self = {};

  $self->{'b21'} = "b21";
  $self->{'b22'} = "b22";

  bless $self, $type;
}


#----------------------------------
package Deripac;
#----------------------------------
@ISA = qw ( Basepac1 Basepac2 );

### Constructor
sub new
{ my $type = shift; 
  my $self = {};

  # Loop over all base classes
  foreach $pac (@ISA)
  { 
    # Call base class constructor
    my $hashref = $pac->new();

    # Merge name spaces of base 
    # classes in the class' own hash
    foreach $key (keys %$hashref)
    { $self->{"$key"} = 
        $$hashref{"$key"};
    }
  }
 
  bless $self, $type;
}

### Sample Method
sub derimethod 
{ my $self = shift;

  # Print all initialized variables
  foreach $key (keys %{$self})
  { print "\$self->{'$key'}=",
          "$self->{$key}\n";
  }
}


#----------------------------------
package main;
#----------------------------------
$derobj = Deripac->new();
$derobj->derimethod();
