:li
#!/usr/bin/perl
#----------------------------------
package Persistent;
#----------------------------------
# Your persistent objects should
# inherit from this class.
#----------------------------------

### Constructor
sub new            
{ my $type = shift;
  my $self = {};
  bless $self, $type;
}

### Store object in file
### Syntax: $objref->store("filename")
sub store
{ my $self = shift;
  my $name = shift;

  # Open the specified file, set the
  # default output filehandle to it
  # and start printing out all 
  # variables and their values.
  open(FILE, ">$name") || return 0;
  my $oldfh = select(FILE);
  ref_deep_print("", $self);
  close(FILE);
  select($oldfh);

  1;
}

### Printout all variables in any 
### depth of the structure of an
### object. 
sub ref_deep_print
{ my $name = shift;
  my $ref  = shift;

  if(!ref($ref))
  { # Printout name and uuencoded 
    # value of a scalar value.
    print "$name\n";
    my $uustring = pack('u', "$ref");
    print "$uustring\n";
  }
  elsif(ref($ref) eq "ARRAY")
  { # Enter recursion for every 
    # member of the array
    for($i=0; $i<=$#$ref; $i++)
    { ref_deep_print("$name\[$i]", 
          $ref->[$i]) if defined $ref->[$i];
    }
  }
  else
  { # Hash or Object:
    # Enter recursion for every 
    # member of the hash/object
    foreach $i (keys %$ref)
    { ref_deep_print("$name\{'$i'}", 
                $ref->{$i});
    }
  }
}

### Load object from file
### Syntax: $objref->load("filename")
sub load
{ my $self   = shift;
  my $name   = shift;

  my($uustring, $string, $varname);

  # Open file and read out variable
  # names and values
  open(FILE, "<$name") || return 0;
  while(<FILE>)
  { 
    # Read variable name
    chop($varname  = $_);

    # get uuencoded value
    $uustring = ""; 
    $uustring .= $line 
      while ($line=<FILE>) !~ /^$/;

    # uudecode value
    $string = unpack('u', $uustring);

    # ... and set variable
    eval "\$self->$varname = \$string";
  }
  close(FILE);
  1;
}

1;
