:li
#!/usr/bin/perl 

use Persistent;

#----------------------------------
package Myclass;
#----------------------------------
# A sample class inheriting the
# persistent features
#----------------------------------
@ISA = qw ( Persistent );

### Constructor
sub new            
{ my $type = shift;
  my $self = Persistent->new();
  bless $self, $type;
}

### Initialize myobject
sub myinit
{ my $self = shift;

  ### Build up a complex object 
  ### structure: Hashes, arrays, 
  ### objects.
  $self->{'the_hash'}   = \%the_hash;
  $self->{'the_array'}  = \@the_array;
  $self->{'the_scalar'} = 
    "This is a scalarvalue that is " .
    "very long and contains specials: " .
    " @,\$,\\,\",'.";

  $the_hash{'hash_key'} = 'hash_value';
  $the_array[1]         = 'array_value';

  ### Create a new object that 
  ### is a part of my object
  my $objref = Myclass->new();
  $objref->{'myobjvar'} = 'myobjvarval';
  $self->{'the_object'} = $objref;
}


#----------------------------------
package main;
#----------------------------------

### Create an object, initialize it 
### and call the save routine.
$myobj = Myclass->new();
$myobj->myinit();
$myobj->store("myobj.sav") || 
  print "Cannot save\n";

### Create a new object and call the 
### load routine to initialize it.
$obj2 = Myclass->new();
$obj2->load("myobj.sav") || 
  print "Cannot load\n";

### Printout object attributes
print 
  "\$obj2->{'the_object'}->{'myobjvar'} = ",
  "$obj2->{'the_object'}->{'myobjvar'}\n";
print 
  "\$obj2->{'the_array'}->[1]           = ",
  "$obj2->{'the_array'}->[1]\n";
print 
  "\$obj2->{'the_hash'}->{'hash_key'}   = ",
  "$obj2->{'the_hash'}->{'hash_key'}\n";
print 
  "\$obj2->{'the_scalar'}               = ",
  "$obj2->{'the_scalar'}\n";
